﻿Imports Infragistics.Web.UI


Public Class Sample2
    Inherits System.Web.UI.Page


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        txtNPOCISDate.Text = "Foo"

        If Not Page.IsPostBack Then
            Dim gridData As DataTable = New DataTable()

            Dim column As DataColumn = gridData.Columns.Add("ID", GetType(Integer))

            column = gridData.Columns.Add("Selected", GetType(Integer))
            column = gridData.Columns.Add("NPOCISDate", GetType(String))
            column = gridData.Columns.Add("NPODate", GetType(String))
            column = gridData.Columns.Add("NPOQty", GetType(String))
            column = gridData.Columns.Add("NPOUMC", GetType(String))
            column = gridData.Columns.Add("NPOVendor", GetType(String))
            column = gridData.Columns.Add("NPOWISDate", GetType(String))

            column = gridData.Columns.Add("CLBrandTitleLegacy", GetType(String))
            column = gridData.Columns.Add("OutstandingCXXLegacy", GetType(String))
            column = gridData.Columns.Add("CLBrandTitle", GetType(String))
            column = gridData.Columns.Add("OutstandingCXX", GetType(String))
            column = gridData.Columns.Add("BackOrderQty", GetType(String))

            column = gridData.Columns.Add("QtyOnHand", GetType(String))
            column = gridData.Columns.Add("ArtDirector", GetType(String))
            column = gridData.Columns.Add("AsstEditor", GetType(String))
            column = gridData.Columns.Add("AcquisitionsEditor", GetType(String))

            column = gridData.Columns.Add("ImageSpecsLogToProdActBegin", GetType(String))
            column = gridData.Columns.Add("QuizMsToProdActBegin", GetType(String))
            column = gridData.Columns.Add("BetaTestActBegin", GetType(String))
            column = gridData.Columns.Add("AudioVideoEditingActBegin", GetType(String))

            column = gridData.Columns.Add("AudioVideoConversionActBegin", GetType(String))
            column = gridData.Columns.Add("InteriorTextColors", GetType(String))
            column = gridData.Columns.Add("PageCount", GetType(String))
            column = gridData.Columns.Add("CoverColorsOutside", GetType(String))

            column = gridData.Columns.Add("Bleeds", GetType(String))
            column = gridData.Columns.Add("CLMetricProductType", GetType(String))
            column = gridData.Columns.Add("RightsSecured", GetType(String))
            column = gridData.Columns.Add("Compositor", GetType(String))

            For gridRowCount As Integer = 1 To 5
                gridData.Rows.Add(gridRowCount, _
                                  (gridRowCount Mod 2), _
                                  String.Format("NPO CIS Date {0}", gridRowCount), _
                                  String.Format("NPO Date {0}", gridRowCount), _
                                  String.Format("NPO Qty {0}", gridRowCount), _
                                  String.Format("NPO UMC {0}", gridRowCount), _
                                  String.Format("NPO Vendor {0}", gridRowCount), _
                                  String.Format("NPO WIS Date {0}", gridRowCount), _
                                  String.Format("CL Brand Title Legacy {0}", gridRowCount), _
                                  String.Format("Outstanding CXX Legacy {0}", gridRowCount), _
                                  String.Format("CL Brand Title {0}", gridRowCount), _
                                   String.Format("Outstanding CXX Legacy {0}", gridRowCount), _
                                   String.Format("Back Order Qty {0}", gridRowCount), _
                                   String.Format("Qty On Hand {0}", gridRowCount), _
                                   String.Format("Art Director {0}", gridRowCount), _
                                   String.Format("Asst Editor {0}", gridRowCount), _
                                   String.Format("Acquisitions Editor {0}", gridRowCount), _
                                   String.Format("Image Specs Log To Prod Act Begin {0}", gridRowCount), _
                                  String.Format("Quiz Ms To Prod Act Begin {0}", gridRowCount), _
                                  String.Format("Beta Test Act Begin {0}", gridRowCount), _
                                  String.Format("Audio Video Editing Act Begin {0}", gridRowCount), _
                                  String.Format("Audio Video Conversion Act Begin {0}", gridRowCount), _
                                  String.Format("Interior Text Colors {0}", gridRowCount), _
                                  String.Format("Page Count {0}", gridRowCount), _
                                  String.Format("CoverColorsOutside {0}", gridRowCount), _
                                  String.Format("Bleeds {0}", gridRowCount), _
                                  String.Format("CL Metric Product Type {0}", gridRowCount), _
                                  String.Format("Rights Secured {0}", gridRowCount), _
                                  gridRowCount.ToString())
            Next

            Dim colTotal As Integer = gridData.Columns.Count - 1
            For colIndex As Integer = 0 To (colTotal) 'Each col As DataColumn In CType(Session("GridData"), DataTable).Columns
                Dim col As DataColumn = gridData.Columns(colIndex)
                Dim piColumnIndex As Integer = -1

                If col.ColumnName = "Selected" Then
                    piColumnIndex = WebDataGrid1.Columns.Add(CreateBoundCheckBoxField(col))
                Else

                    Dim bc As Infragistics.Web.UI.GridControls.BoundDataField = New Infragistics.Web.UI.GridControls.BoundDataField()

                    bc.Key = col.ColumnName
                    bc.Header.Text = col.ColumnName
                    bc.DataType = col.DataType.ToString()
                    bc.Width = 70

                    piColumnIndex = WebDataGrid1.Columns.Add(bc)

                    If col.ColumnName = "Compositor" Then
                        'Image field
                        WebDataGrid1.Columns(piColumnIndex).Hidden = True

                        Dim psHeaderImageUrl As String = GetWebColumnHeaderImage()
                        Dim psImageColumnName As String = WebDataGrid1.Columns(piColumnIndex).Key & "_Indicator"
                        Dim poImageColumn As DataColumn = gridData.Columns.Add(psImageColumnName, GetType(System.Object))

                        poImageColumn.ColumnName = psImageColumnName
                        poImageColumn.Caption = col.Caption

                        piColumnIndex = WebDataGrid1.Columns.Add(CreateImageTemplateDataField(poImageColumn, psHeaderImageUrl, col.Caption))
                    End If
                End If
            Next

            Session("GridData") = gridData

            WebDataGrid1.DataSource = Session("GridData")
            WebDataGrid1.DataBind()
            WebDataGrid1_RowSelectionChanged(Nothing, Nothing)

        Else
            WebDataGrid1.DataSource = Session("GridData")
            WebDataGrid1.DataBind()
        End If
    End Sub


    Private Function GetWebColumnHeaderImage() As String
        Dim psWebColumnHeaderImage As String = String.Empty

        Try
            psWebColumnHeaderImage = "~/Images/AlertLevel.png"

            If psWebColumnHeaderImage Is Nothing OrElse psWebColumnHeaderImage.Length = 0 Then
                psWebColumnHeaderImage = "~/Images/Empty.jpg"
            End If
        Catch ex As Exception
            Throw ex
        End Try

        Return psWebColumnHeaderImage
    End Function


    Public Function CreateImageTemplateDataField(poImageColumn As DataColumn, psHeaderImageUrl As String, psHeaderAlternateText As String) As Infragistics.Web.UI.GridControls.TemplateDataField
        Dim poTemplatedColumn As Infragistics.Web.UI.GridControls.TemplateDataField = New Infragistics.Web.UI.GridControls.TemplateDataField(True)

        Try
            poTemplatedColumn.ItemTemplate = New CustomImageColumnHeader("~/Images/Empty.jpg", "No Value Set")

            poTemplatedColumn.Key = poImageColumn.ColumnName
            poTemplatedColumn.Header.Tooltip = poImageColumn.Caption

            If psHeaderImageUrl.Length = 0 Then
                poTemplatedColumn.Header.Text = psHeaderAlternateText
            Else
                Dim poImageHAlignment As WebControls.ImageAlign = ImageAlign.Middle
                Dim columnHeaderTemplate As CustomImageColumnHeader = New CustomImageColumnHeader(psHeaderImageUrl, psHeaderAlternateText, poImageHAlignment)

                poTemplatedColumn.HeaderTemplate = columnHeaderTemplate
                poTemplatedColumn.Header.Text = String.Empty
            End If
            poTemplatedColumn.Width = 100

        Catch ex As Exception
            Throw ex
        End Try

        Return poTemplatedColumn
    End Function


    Public Function CreateBoundCheckBoxField(poColumn As DataColumn) As GridControls.BoundCheckBoxField
        Dim poBoundCheckboxColumn As GridControls.BoundCheckBoxField = New GridControls.BoundCheckBoxField(True)

        Try
            poBoundCheckboxColumn.Key = poColumn.ColumnName
            poBoundCheckboxColumn.DataFieldName = poColumn.ColumnName
            poBoundCheckboxColumn.DataType = poColumn.DataType.ToString()
            poBoundCheckboxColumn.Header.Text = poColumn.ColumnName
            poBoundCheckboxColumn.Header.Tooltip = poColumn.ColumnName

            poBoundCheckboxColumn.Width = 70

            '-- Not Editable
            poBoundCheckboxColumn.CssClass = "readonly-cell"

            Select Case poColumn.DataType.ToString()
                Case GetType(System.String).ToString()
                    poBoundCheckboxColumn.ValueConverter = New CustomBooleanConverter("No", "Yes", poColumn.ColumnName)

                Case GetType(System.Int32).ToString()
                    poBoundCheckboxColumn.ValueConverter = New CustomBooleanConverter(0, 1, poColumn.ColumnName)
            End Select

            poBoundCheckboxColumn.Hidden = False

        Catch ex As Exception
            Throw ex
        End Try

        Return poBoundCheckboxColumn
    End Function


    Private Sub WebDataGrid1_InitializeRow(sender As Object, e As Infragistics.Web.UI.GridControls.RowEventArgs) Handles WebDataGrid1.InitializeRow
        Try
            Dim currentRow As GridControls.GridRecord = e.Row

            Dim alertLevel As GridControls.GridRecordItem = currentRow.Items.FindItemByKey("Compositor")
            Dim alertLevelImage As GridControls.GridRecordItem = currentRow.Items.FindItemByKey("Compositor_Indicator")

            If alertLevel IsNot Nothing AndAlso alertLevel.Value IsNot DBNull.Value Then
                Dim poHeaderImageAlignment As System.Web.UI.WebControls.ImageAlign = ImageAlign.Middle

                If alertLevelImage.Column.Header.TemplateContainer IsNot Nothing AndAlso alertLevelImage.Column.Header.TemplateContainer.Controls.Count = 1 AndAlso _
                            alertLevelImage.Column.Header.TemplateContainer.Controls(0).GetType().Equals(GetType(Image)) Then
                    Dim poHeader As Image = CType(alertLevelImage.Column.Header.TemplateContainer.Controls(0), Image)

                    poHeaderImageAlignment = poHeader.ImageAlign
                End If

                Select Case alertLevel.Value
                    Case "1"
                        alertLevelImage.Tooltip = alertLevel.Value

                        SetupImageColumnTemplate(alertLevelImage.Template, "~/Images/AlertGreen.gif", alertLevel.Value, poHeaderImageAlignment)

                    Case "2"
                        alertLevelImage.Tooltip = alertLevel.Value

                        SetupImageColumnTemplate(alertLevelImage.Template, "~/Images/AlertYellow.gif", alertLevel.Value, poHeaderImageAlignment)

                    Case "3"
                        alertLevelImage.Tooltip = alertLevel.Value

                        SetupImageColumnTemplate(alertLevelImage.Template, "~/Images/AlertRed.gif", alertLevel.Value, poHeaderImageAlignment)

                    Case Else
                        alertLevelImage.Tooltip = "None"

                        SetupImageColumnTemplate(alertLevelImage.Template, String.Empty, String.Empty, poHeaderImageAlignment)
                End Select
            End If
        Catch ex As Exception
            Throw
        End Try
    End Sub


    Private Sub SetupImageColumnTemplate(ByRef imageColumnTemplate As CustomImageColumnHeader, psImageUrl As String, psAlternateText As String, poImageAlignment As WebControls.ImageAlign)
        Try
            If imageColumnTemplate Is Nothing Then
                imageColumnTemplate = New CustomImageColumnHeader(psImageUrl, psAlternateText, poImageAlignment)
            Else
                imageColumnTemplate.ImageUrl = psImageUrl
                imageColumnTemplate.AlternateText = psAlternateText
                imageColumnTemplate.ImageAlignment = poImageAlignment
                imageColumnTemplate.SetValues()
            End If
        Catch ex As Exception
            Throw
        End Try
    End Sub


    Public Sub WebDataGrid1_RowSelectionChanged(sender As Object, args As Infragistics.Web.UI.GridControls.SelectedRowEventArgs) Handles WebDataGrid1.RowSelectionChanged
        Try
            If WebDataGrid1.Behaviors.Selection.SelectedRows.Count = 0 Then
                If WebDataGrid1.Rows.Count > 0 Then
                    WebDataGrid1.Behaviors.Selection.SelectedRows.Add(WebDataGrid1.Rows(0))
                End If
            End If

            If WebDataGrid1.Behaviors.Selection.SelectedRows.Count = 1 Then
                Dim selectedRecord As Infragistics.Web.UI.GridControls.GridRecord = WebDataGrid1.Behaviors.Selection.SelectedRows(0)

                txtNPOCISDate.Text = selectedRecord.Items.FindItemByKey("NPOCISDate").Value
                'txtNPODate.Text = selectedRecord.Items.FindItemByKey("NPODate").Value
                'txtNPOQty.Text = selectedRecord.Items.FindItemByKey("NPOQty").Value
                'txtNPOUMC.Text = selectedRecord.Items.FindItemByKey("NPOUMC").Value
                'txtNPOVendor.Text = selectedRecord.Items.FindItemByKey("NPOVendor").Value
                'txtNPOWISDate.Text = selectedRecord.Items.FindItemByKey("NPOWISDate").Value
                'txtCLBrandTitleLegacy.Text = selectedRecord.Items.FindItemByKey("CLBrandTitleLegacy").Value
                'txtOutstandingCXXLegacy.Text = selectedRecord.Items.FindItemByKey("OutstandingCXXLegacy").Value
                'txtCLBrandTitle.Text = selectedRecord.Items.FindItemByKey("CLBrandTitle").Value
                'txtOutstandingCXX.Text = selectedRecord.Items.FindItemByKey("OutstandingCXX").Value
                'txtBackOrderQty.Text = selectedRecord.Items.FindItemByKey("BackOrderQty").Value
                'txtQtyOnHand.Text = selectedRecord.Items.FindItemByKey("QtyOnHand").Value
                'txtArtDirector.Text = selectedRecord.Items.FindItemByKey("ArtDirector").Value
                'txtAsstEditor.Text = selectedRecord.Items.FindItemByKey("AsstEditor").Value

                'txtAcquisitionsEditor.Text = selectedRecord.Items.FindItemByKey("AcquisitionsEditor").Value
                'txtImageSpecsLogToProdActBegin.Text = selectedRecord.Items.FindItemByKey("ImageSpecsLogToProdActBegin").Value
                'txtQuizMsToProdActBegin.Text = selectedRecord.Items.FindItemByKey("QuizMsToProdActBegin").Value
                'txtBetaTestActBegin.Text = selectedRecord.Items.FindItemByKey("BetaTestActBegin").Value
                'txtAudioVideoEditingActBegin.Text = selectedRecord.Items.FindItemByKey("AudioVideoEditingActBegin").Value
                'txtAudioVideoConversionActBegin.Text = selectedRecord.Items.FindItemByKey("AudioVideoConversionActBegin").Value
                'txtInteriorTextColors.Text = selectedRecord.Items.FindItemByKey("InteriorTextColors").Value
                'txtPageCount.Text = selectedRecord.Items.FindItemByKey("PageCount").Value

                'txtCoverColorsOutside.Text = selectedRecord.Items.FindItemByKey("CoverColorsOutside").Value
                'txtBleeds.Text = selectedRecord.Items.FindItemByKey("Bleeds").Value
                'txtCLMetricProductType.Text = selectedRecord.Items.FindItemByKey("CLMetricProductType").Value
                'txtRightsSecured.Text = selectedRecord.Items.FindItemByKey("RightsSecured").Value
                'txtCompositor.Text = selectedRecord.Items.FindItemByKey("Compositor").Value
            End If
        Catch ex As Exception
            Throw
        End Try
    End Sub

    Private Sub cmdButton_Click(sender As Object, e As System.EventArgs) Handles cmdButton.Click
        txtNPOCISDate.Text = "BOO"
    End Sub
End Class